use actix_web_actors::ws::WebsocketContext;
use serde::{Deserialize, Serialize};

#[derive(Serialize, Debug)]
pub enum DownMsg {
    Greeting(String),
    TimeUpdate(String),
}

#[derive(Deserialize, Debug)]
pub enum UpMsg {
    RequestGreet(String),
}

pub fn msg_handler(
    msg: UpMsg,
    ws: &mut crate::MyWebSocket,
    ctx: &mut WebsocketContext<crate::MyWebSocket>,
) {
    match msg {
        UpMsg::RequestGreet(name) => {
            let greeting = format!("Hello, {}!", name);
            let response = crate::DownMsg::Landing(DownMsg::Greeting(greeting));
            ws.send_down_msg(response, ctx);
        }
    }
}
